# You will need to have python 2.7 (3+ may work)
# and PyUSB 1.0
# and PIL 1.1.6 or better
# and numpy
# and scipy
# and ImageMagick

# ALSO now requires 
# CV2
# python-opencv
# Rsaspbian needed to have libgl1-mesa-dri installed


# Many thanks to the folks at eevblog, especially (in no particular order) 
#   miguelvp, marshallh, mikeselectricstuff, sgstair and many others
#     for the inspiration to figure this out
# This is not a finished product and you can use it if you like. Don't be
# surprised if there are bugs as I am NOT a programmer..... ;>))


# Thanks to the above & whoever posted the original live-display version on github under fry-kun
# that was what I needed to get started.  I too am NOT a trained programmer, so I am 
# sure there are many things here and in the C module that are not done properly in the eyes of a programmer
# But this works for me.
# Having never touched Python before, I have added the following:

#The letters specified below must be lower case only
#press the s key to save a frame to a png file (file name includes date & time)
#press the l key to save a frame as a text list of pixel values (always same file name)
#press the c key to generate a pixel correction factor file
#    That file is used in place of frame of status 10 and can yield
#    cleaner images than you get from using frame of status 10 (aka frameID10)
#press the b key to toggle between grayscale & color image
#press the v key to toggle video record on & off  (always same file name); keeps adding to same file until program is closed
#left-click on a pixel to display temperature; up to 5 markers can be displayed at once & they keep updating
#    pixel temperature markers will be on saved images & videos
#right-click in the window to turn off all markers
#Press 9 to toggle pixel smoothing which averages in the 8 surrounding pixels at each pixel

#Press t to toggle use of the attempted "black-body shutter" calibration (disabled in this version)
#    This is an attempt at compensating for the fact that the IR from the shutter
#    hits the sensor without going through the lens.  A certain research paper 
#    showed significant improvement in accuracy doing that but I haven't realized it yet
#
# Press i to toggle internal (frameID10) vs. external pixel scaling factors
#
#pixelmath module for doing pixel correction.  This does the following:
#    calculates image pixel values from image & cal frames
#    assign zero pixels the value from prior pixel
#    applies pixel by pixel scale factors from frame of status 10 and/or cal file generated by "the user"
#    loads image data into an RGB array
#    A separate module function swaps R & B in the color array so video will be saved properly by cv2
#    Doing all of that in python slowed video down to 1 frame/3 seconds on a 2.4GHz laptop, maxing out one core
#    In compiled C it only takes 3% of cpu time (out of 4 cores) to get 8-9fps
# I have a color palette that attempts to give a uniquely recognizable color for every degree Fahrenheit.
# In a sense it does, but only by repeating it 3 times...

### Second pixel contains a measure of sensor temperature.  For 78F at startup the value is 4371 on my camera
### With the camera at 34F the number was 4779 on 8-10-15  
### This calculates to about 10 per degree

import usb.core
import usb.util
import Tkinter
from Tkinter import *
from PIL import Image, ImageTk, ImageFont, ImageDraw
import numpy
from scipy.misc import toimage
import sys, os, time
import cv2
import datetime
 
import pixelmath

## BEWARE! fonts & location may be different on your system
##This is now commented out since the config file takes care of it
global font
#font = ImageFont.truetype("/usr/share/fonts/truetype/freefont/FreeMonoBold.ttf",25)

# find our Seek Thermal device  289d:0010
dev = usb.core.find(idVendor=0x289d, idProduct=0x0010)
if not dev: raise ValueError('Device not found')

def send_msg(bmRequestType, bRequest, wValue=0, wIndex=0, data_or_wLength=None, timeout=None):
    assert (dev.ctrl_transfer(bmRequestType, bRequest, wValue, wIndex, data_or_wLength, timeout) == len(data_or_wLength))

# alias method to make code easier to read
receive_msg = dev.ctrl_transfer

def deinit():
    '''Deinit the device'''
    msg = '\x00\x00'
    for i in range(3):
        send_msg(0x41, 0x3C, 0, 0, msg)


# set the active configuration. With no arguments, the first configuration will be the active one
dev.set_configuration()

# get an endpoint instance
cfg = dev.get_active_configuration()
intf = cfg[(0,0)]

custom_match = lambda e: usb.util.endpoint_direction(e.bEndpointAddress) == usb.util.ENDPOINT_OUT
ep = usb.util.find_descriptor(intf, custom_match=custom_match)   # match the first OUT endpoint
assert ep is not None


# Setup device
try:
    msg = '\x01'
    send_msg(0x41, 0x54, 0, 0, msg)
except Exception as e:
    deinit()
    msg = '\x01'
    send_msg(0x41, 0x54, 0, 0, msg)

#  Some day we will figure out what all this init stuff is and
#  what the returned values mean.

send_msg(0x41, 0x3C, 0, 0, '\x00\x00')
ret1 = receive_msg(0xC1, 0x4E, 0, 0, 4)
#print ret1
ret2 = receive_msg(0xC1, 0x36, 0, 0, 12)
#print ret2

send_msg(0x41, 0x56, 0, 0, '\x20\x00\x30\x00\x00\x00')
ret3 = receive_msg(0xC1, 0x58, 0, 0, 0x40)
#print ret3

send_msg(0x41, 0x56, 0, 0, '\x20\x00\x50\x00\x00\x00')
ret4 = receive_msg(0xC1, 0x58, 0, 0, 0x40)
#print ret4

send_msg(0x41, 0x56, 0, 0, '\x0C\x00\x70\x00\x00\x00')
ret5 = receive_msg(0xC1, 0x58, 0, 0, 0x18)
#print ret5

send_msg(0x41, 0x56, 0, 0, '\x06\x00\x08\x00\x00\x00')
ret6 = receive_msg(0xC1, 0x58, 0, 0, 0x0C)
#print ret6

send_msg(0x41, 0x3E, 0, 0, '\x08\x00')
ret7 = receive_msg(0xC1, 0x3D, 0, 0, 2)
#print ret7

send_msg(0x41, 0x3E, 0, 0, '\x08\x00')
send_msg(0x41, 0x3C, 0, 0, '\x01\x00')
ret8 = receive_msg(0xC1, 0x3D, 0, 0, 2)
#print ret8

# make a color pallette  The goal was one unique color for every degree Farenheit, 
# but I haven't gotten there yet
global palarray

def makepallette():
   global palarray
   palarray = numpy.zeros((666,3), dtype=numpy.uint8)
   r = 0
   g = 0
   b = 0
   ir = 25
   ig = 25
   ib = 25

   ic = 0
   ik = 0
   ix = 0
   col = 0

   palarray[col][0] = r
   palarray[col][1] = g
   palarray[col][2] = b
   col = col+1

   palarray[col][0] = r+20
   palarray[col][1] = g
   palarray[col][2] = b
   col = col+1

   palarray[col][0] = r
   palarray[col][1] = g+20
   palarray[col][2] = b
   col = col+1

   palarray[col][0] = r
   palarray[col][1] = g
   palarray[col][2] = b+20
   col = col+1


   r = 0
   g = 0
   b = 0
   ik = 0
   ic = 12
   #grays
   while ik < 5:
       g = g+ic
       b = b+ic
       r = r+ic
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       ic = ic-1
       col = col+1
       ik = ik +1

   g = 0
   r = -10
   b = 25
   ik = 0
   ic = 15
   #dark part of purples like the greens
   while ik < 4:
       b = b+8
       r = r+ic
       g=g+5
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       b = b+7
       r = r+ic-2
       g=g+5
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       ic = ic -0
       ik = ik +1

   g = 0
   r = -10
   b = 95
   ik = 0
   ic = 15
   #dark part of middle purple set like the greens
   while ik < 4:
       b = b+8
       r = r+ic
       g=g+5
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       b = b+7
       r = r+ic-2
       g=g+5
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       ic = ic -0
       ik = ik +1

   g = 20
   r = -10
   b = 95
   ik = 0
   ic = 15
   #darkest of top set of purples like the greens
   while ik < 3:
       b = b+8
       r = r+ic
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       b = b+7
       r = r+ic-2
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       ic = ic -0
       ik = ik +1


   g = 0
   r = 0
   b = 40
   ik = 0
   ic = 20
   #try for blues like the greens
   while ik < 9:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       g = g+5
       b = b+ic
       ic = ic -0
       ik = ik +1

   g = 20
   r = 0
   b = 50
   ik = 0
   ic = 20
   #try for more blues like the greens
   while ik < 9:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       g = g+5
       b = b+ic
       ic = ic -1
       ik = ik +1

   g = 40
   r = 0
   b = 60
   ik = 0
   ic = 20
   #try for another set of blues like the greens
   while ik < 9:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       g = g+5
       b = b+ic
       ic = ic -1
       ik = ik +1

   g = 30
   r = 0
   b = 130
   ik = 2
   ic = 15
   #try for medium blues like the greens
   while ik < 9:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       g = g+5
       b = 115+ic*ik
       ic = ic -0
       ik = ik +1

   g = 70
   r = 0
   b = 130
   ik = 2
   ic = 15
   #try for medium blues like the greens
   while ik < 9:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       g = g+5
       b = 115+ic*ik
       ic = ic -0
       ik = ik +1

   g = 110
   r = 0
   b = 130
   ik = 2
   ic = 15
   #try for medium blues like the greens
   while ik < 9:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       g = g+9
       b = 115+ic*ik
       ic = ic -0
       ik = ik +1

   g = 90
   r = 0
   b = 130
   ik = 2
   ic = 15
   #try for green-blues like the greens
   while ik < 9:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       g = g+ic
       b = 100+ic*ik
       ic = ic -0
       ik = ik +1



   r = 30
   g = 75
   b = 70
   ik = 0
   #blue-greens
   while ik < 14:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       g = g+10
       b = b+9
       ik = ik +1

   r = 0
   g = 95
   b = 50
   ik = 0
   ic = 25
   #greens
   while ik < 6:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       g = g+ic
       b = b+5
       ic = ic -2
       ik = ik +1

   r = 0
   g = 100
   b = 10
   ik = 0
   #more greens
   while ik < 9:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       g = g+15
       b = b+15
       ik = ik +1


   g = 0
   r = 87
   b = 147
   ik = 0
   ic = 15
   #try for a set of purples like the greens
   while ik < 10:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       b = b+10
       r = r+ic
       g=g+15
       ic = ic -1
       ik = ik +1

   g = 25
   r = 87
   b = 147
   ik = 0
   ic = 17
   #try for a set of purples like the greens
   while ik < 8:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       b = b+10
       r = r+ic
       g=g+15
       ic = ic -0
       ik = ik +1

   g = 55
   r = 145
   b = 178
   ik = 0
   ic = 15
   #try for a 3rd set of purples like the greens
   while ik < 10:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       b = b+8
       g=g+5
       r = r+ic
       ic = ic -1
       ik = ik +1


   g = 35
   r = 111
   b = 115
   ik = 0
   ic = 21
   #try for another set of purples like the greens
   while ik < 9:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       r = r+ic
       g=g+5
       ic = ic -1
       ik = ik +1


   g = 35
   r = 111
   b = 95
   ik = 0
   ic = 21
   #try for another set of purples like the greens
   while ik < 9:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       r = r+ic
       g=g+5
       ic = ic -1
       ik = ik +1


   g = 35
   r = 111
   b = 75
   ik = 0
   ic = 21
   #try for another set of purples like the greens
   while ik < 9:
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       r = r+ic
       g=g+5
       ic = ic -1
       ik = ik +1


   g = 0
   r = 50
   b = 0
   ik = 0
   ic = 25
   #try for a set of reds like the greens
   while ik < 5:
       r = r+ic
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       r = r+ic-5
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       ic = ic -2
       ik = ik +1


   r = 230
   g = -25
   b = 0
   ik = 0
   #inbetween red
   while ik < 4:
       g = g+25
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       b = b+ib
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       ik = ik +1

   r = 255
   g = 120
   b = 0
   ik = 0
   i = 0
   #light orange?
   while i <1:
      ik=0
      g = 120
      b = 0
      while ik < 10:
        g = g+10
        b = b+15
        palarray[col][0] = r
        palarray[col][1] = g
        palarray[col][2] = b
        col = col+1
        ik = ik +1
      i=i+1



   r = 230
   g = 100
   b = 0
   ik = 0
   #orange to yellow
   while ik < 10:
       g = g+15
       b = b+5
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       ik = ik +1


   r = 0
   g = 0
   b = 0
   ix = 5
   ik = 3


   ix=0
   r = 0
   while ix < 3:
     r=30*ix
     
     g = 0
     b = 0
     ik = 0
     ic = 22
     #grays
     while ik < 5:
         g = g+ic
         b = b+ic+5
         r = r+ic
         palarray[col][0] = r
         palarray[col][1] = g
         palarray[col][2] = b
         col = col+1
         ic = ic-2
         ik = ik +1
     ix=ix+1

   r = 0
   g = 25
   b = 0
   ik = 0
   ic = 22
   #grays
   while ik < 5:
       g = g+ic
       b = b+ic+5
       r = r+ic
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       ic = ic-2
       col = col+1
       ik = ik +1

   r = 50
   g = 100
   b = 100
   ik = 0
   #more grays
   while ik < 10:
       g = g+15
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       b = b+15
       r = r+15
       palarray[col][0] = r
       palarray[col][1] = g
       palarray[col][2] = b
       col = col+1
       ik = ik +1

   palmax = col


#Fill the rest of the array with white...OR maybe better repeat it:
   while col < 666:
     palarray[col][0] = palarray[col-palmax][0]
     palarray[col][1] = palarray[col-palmax][1]
     palarray[col][2] = palarray[col-palmax][2]

     col = col +1
   return palarray
global kclrs
kclrs = makepallette()


#def onmouse(event, x, y, flags, param):
  #  if event == cv2.EVENT_LBUTTONDOWN:
     #  print(x,y)

#cv2.setMouseCallback('pallette', onmouse) #Don't need the callback, just needed to put the waitkey in the main loop


 
global saveit, bwcolor, pixelcorr, listfile, avgcal, calbfr, tamfx22, rgbbfr, badpxls, bwbfr, noraster, videorec, applyoffs
global btndown, xcoord, ycoord, Nmarkers, tempstr, diffcurve, curvebase, negoffsets, basevalues, pixl1
global freezeframe, avg9, imgscale, scalebfr, firstcalframe, shutterbb, useshuttercal, ForC, mkr1tamf, tzoom
global frame10, useframe10, refbfr, useframe1, imgw, imgh, diffshouldbe, ambientT, pixel1atT, sensrref

saveit = -1
bwcolor = -1
pixelcorr = 1
listfile = -1
noraster = 1
videorec = -1
avgcal = -1
btndown = -1
xcoord = [0, 1, 2, 3, 4]
ycoord = [0, 1, 2, 3, 4]
tempstr = ["t","e","m","p","1"]
Nmarkers = 0
applyoffs = -1
freezeframe = -1
avg9 = 1
useshuttercal = -1
ForC = 1
mkr1tamf = 0
tzoom = -1
useframe10 = -1
useframe1 = 1
imgw = 206
imgh = 156
diffshouldbe = -400
ambientT = 78
pixel1atT = 4371
sensrref = 7679
Rpiscreen = 0

# Scale the image up to increase visibility.  
# 3x is particularly to get full screen on the Raspberry Pi2B with a 5" LCD screen
# Unfortunately, when scaled to 3x it only yields 4fps on the Pi (but CPU meter does NOT show a core maxed)
# 2x scale runs fine at full frame rate, though
# To run full screen on the 5" Pi, you need to uncomment the "overrideredirect" line

imgscale = 2

firstcalframe= 0 #setting this to -1 makes it NOT write first frame list file

##### Read in config file
cfg = open("config.txt", 'r')
line="  "
while len(line) >0:
  line = cfg.readline()
  if line !='':
    if(line[0] != '#') :
      param, value = line.split("=")
      if( (param == "ForC") & (value == "F\n") ): ForC = 1
      if( (param == "ForC") & (value == "C\n") ): ForC = -1
      if( param == "ambientT" ): ambientT = float(value)
      if( param == "pixel1atT" ): pixel1atT = int(value)
      if( param == "diffshouldbe" ): diffshouldbe = int(value)
      if( (param == "useframe10") & (value == "yes\n") ): useframe10 = 1
      if( (param == "useframe10") & (value == "no\n") ): useframe10 = -1
      if( param == "imgscale" ): imgscale = int(value)
      if( param == "font" ): font = ImageFont.truetype(value[:len(value)-1],24)#MUST specify length to drop the "newline" char at end
      if( param == "Rpiscreen" ): Rpiscreen = int(value)
cfg.close()

if(ForC < 0): ambientT = ambientT*1.8 + 32 #convert to Fahrenheit for use in finding ref point on curve


# Define the codec and create VideoWriter object
fourcc = cv2.cv.CV_FOURCC('X','V','I','D')
global out
out = cv2.VideoWriter('thermalvideo.avi',fourcc, 7, (imgscale*imgw,imgscale*imgh), 1)


def callback2(event):    
        global bwcolor   
        bwcolor = -1*bwcolor   

def callback2b():    
        global bwcolor   
        bwcolor = -1*bwcolor   

def callback3(event):    
        global pixelcorr   
        pixelcorr = -1*pixelcorr   

def callback4(event):    
        global listfile   
        listfile = -1*listfile   

def callback5(event):    
        global noraster   
        noraster = -1*noraster   

def callback6b():    
        global videorec, out   
        videorec = -1*videorec   
        if (bwcolor > 0): videoclr = 0
        if (bwcolor < 0): videoclr = 1
     #   if((videorec > 0) & (bwcolor >0)): out = cv2.VideoWriter('output.avi',fourcc, 9, (1248,312), videoclr)
      #  if ((videorec > 0) & (bwcolor <0)): out = cv2.VideoWriter('output.avi',fourcc, 9, (416,312), 1)
     #   if (videorec < 0): out.close()

def callback6(event):    
        global videorec, out   
        videorec = -1*videorec   
        if (bwcolor > 0): videoclr = 0
        if (bwcolor < 0): videoclr = 1

def callback7(event):   #calibrate--make pixel correction factor file
        global avgcal 
        avgcal = -1*avgcal 

def calavg():   #calibrate button--make pixel correction factor file
        global avgcal 
        avgcal = -1*avgcal 

def freezeit():   #freeze capture; hold current frame display
        global  freezeframe
        freezeframe = -1*freezeframe 

def avg9pxl(event):   #Average 8 surrounding pixels at each pixel for display only--marker data is still every degree
        global  avg9
        avg9 = -1*avg9 

def avg9pxlb():   #Average 8 surrounding pixels at each pixel for display only--marker data is still every degree
        global  avg9
        avg9 = -1*avg9 

def FahCent(event):   #Select Fahrenheit or Centigrade
        global  ForC
        ForC = -1*ForC 

def FahCentb():   #Select Fahrenheit or Centigrade
        global  ForC
        ForC = -1*ForC 

def zoomtemp(event):   #zoom palette to marker 1 temperature with .5 degree F resolution, maybe .25 later???
        global  tzoom
        tzoom = -1*tzoom 

def zoomtempb():   #zoom palette to marker 1 temperature with .5 degree F resolution, maybe .25 later???
        global  tzoom
        tzoom = -1*tzoom 

def mouseclick(event):   #capture mouse click to get coordinates
        global btndown, xcoord, ycoord, Nmarkers
        if Nmarkers < 5:
             Nmarkers = Nmarkers +1
        xcoord[Nmarkers-1] = event.x
        ycoord[Nmarkers-1] = event.y
        btndown = 1

def Rmouseclick(event):   #capture right mouse click to clear markers
        global Nmarkers
        Nmarkers = 0

def clearmkrs():   #reset markers on touch-screen where don't have right mouse button
        global Nmarkers
        Nmarkers = 0

def mouseunclick(event):   #capture mouse un-click
        global btndown
        btndown = -1

def offsetonoff(event):   #turn on/off applying diff curve offsets
        global applyoffs
        applyoffs = applyoffs * -1

def shuttercalonoff(event):   #turn on/off applying shutter cal
        global useshuttercal
        useshuttercal = useshuttercal * -1

def internalcal(event):   #toggle internal/external pixel cal factors
        global useframe10
        useframe10 = useframe10 * -1
        if(useframe10 <0): readpixelcal()
        if(useframe10 >0): setframe10cal()

def internalref(event):   #toggle internal/external reference frame (frame 3 or external)
        global useframe1
        useframe1 = useframe1 * -1
        if(useframe1 >0): readrefframe()

diffcurve = numpy.zeros((13320, 2), dtype=numpy.uint8)
calbfr = numpy.zeros((64896), dtype=numpy.uint8)
refbfr = numpy.zeros((64896), dtype=numpy.uint8)
stripbfr = numpy.zeros((64896), dtype=numpy.uint8)
tamfx22 = numpy.zeros((64896), dtype=numpy.uint8)
rgbbfr = numpy.zeros((97344), dtype=numpy.uint8)
frame10 = numpy.zeros((64896), dtype=numpy.uint8)
badpxls = numpy.zeros((32448), dtype=numpy.uint8)
bwbfr = numpy.zeros((32448), dtype=numpy.uint8)
negoffsets = numpy.zeros((64896), dtype=numpy.int16) #Don't need uint 8 here since I don't write to it in C
basevalues = numpy.zeros((64896), dtype=numpy.uint8)
scalebfr = numpy.zeros((imgscale*imgscale*97344), dtype=numpy.uint8)
shutterbb = numpy.zeros((32448), dtype=numpy.int16) #Don't need uint 8 here since I don't write to it in C

##### Stuff for getting average of many frames for cal purposes
global sumofimg, sumofcal, avgframes
sumofimg = numpy.zeros((32448), dtype=numpy.int32) #For summing & averaging multiple scene frames
sumofcal = numpy.zeros((32448), dtype=numpy.int32) #For summing & averaging multiple scene frames
avgframes = -1

def readrefframe():
  global  refbfr
  fp = open("referenceframe.txt", 'r')
  ix = 0
  while ix < imgw*imgh:
    s = fp.readline()
    refbfr[2*ix] = int(s) & 0xff #
    refbfr[2*ix +1]  = (int(s) >>8) & 0xff #
    ix=ix+1
  fp.close()

def readpixelcal():
  global badpxls
  fp = open("pixelcal.txt", 'r')
  ix = 0
  while ix < imgh*imgw:
      s = fp.readline()
      badpxls[ix]  = int(s)
      ix=ix+1
  fp.close()

readpixelcal()
#readrefframe()

def setframe10cal():
            global badpxls, frame10
            ix = 0
            while ix < imgw*imgh:
              badpxls[ix]  = frame10[2*ix] 
              ix=ix+1


#########
#Stuff to get some information on startup changes in image data
global writetestfile, ftest, nimage
nimage = 0
writetestfile = -1

if (writetestfile > 0):
  ftest = open("testfile.txt", 'w')
  s =  "frame#\tpixel1\tpxl44\tcal44\tdiff44\tpxl100\tcal100\tdiff100\tpxl130\tcal130\tdiff130"  + "\n"
  ftest.write(s)
#########


#########
#Stuff to try to better track temperature changes in the device
global priorcalframe, thiscalframe, priorcalvalue, thiscalvalue, calpixel, correction

priorcalframe = 0
thiscalframe = 0
priorcalvalue = 0
thiscalvalue = 0
calpixel = 118
correction = 0
#########
global firstscene, firstimg, firstcal, nshutter
firstscene = 0
firstimg = 0
firstcal = 0
nshutter = 0

im2arrF = None
def get_image():
    global im2arrF, font, btndown, saveit, listfile, avgcal, Nmarkers, xcoord, ycoord, applyoffs, pixl1
    global kclrs, calbfr, tamfx22, rgbbfr, badpxls, bwbfr, out, diffcurve, curvebase, negoffsets, basevalues
    global e, freezeframe, avg9, imgscale, firstcalframe, shutterbb, useshuttercal, firstscene
    global ForC, mkr1tamf, tzoom, frame10, refbfr, useframe1, imgw, imgh
    global sensrref, diffshouldbe, ambientT, pixel1atT

    ######### For averaging multiple frames--function removed for distribution
    global sumofimg, sumofcal, avgframes, firstimg, firstcal, nshutter

    #########for test file
    global  writetestfile, ftest, nimage, pxl40, correction

    #########
    #Stuff to try to better track temperature changes in the device
    global priorcalframe, thiscalframe, priorcalvalue, thiscalvalue, calpixel

    while True:
        # Send read frame request
        send_msg(0x41, 0x53, 0, 0, '\xC0\x7E\x00\x00')

        try:
            ret9  = dev.read(0x81, 0x3F60, 1000)
            ret9 += dev.read(0x81, 0x3F60, 1000)
            ret9 += dev.read(0x81, 0x3F60, 1000)
            ret9 += dev.read(0x81, 0x3F60, 1000)
        except usb.USBError as e:
            sys.exit()

        #  Let's see what type of frame it is
        #  3 is a Normal frame, 1 is a Calibration frame
        #  6 may be a pre-calibration frame
        #  5, 10 other... who knows.
        status = ret9[20]
        #print ('%5d'*21 ) % tuple([ret9[x] for x in range(21)])

        #for test purposes, write list files for unused startup frames
#        if ((status != 1) & (status != 3) ):
 #              s = "pixelfile" +str(status) + ".txt"
  #             f0 = open(s, 'w')
   #            s = "pxl#\t  image"  + "\n"
    #           f0.write(s)
     #          ix = 0
      #         while ix < imgw*imgh:
       #          s = str(ix) + "\t"  + str( (ret9[2*ix+1]<<8) + ret9[2*ix]) +"\n"
        #         f0.write(s)
         #        ix=ix+1
          #     f0.close()

        if status == 4:
            #  Are these the base numbers for the curve for each pixel?  
            # Instead of the 2000 that is in "frame" 9?
            #  If so, do they need to be scaled by the factors of "Frame" 10?
            #  Scaled values are very close to 2000 (1777-2181 with about 27 below 2000),
            #  so I vote for scaled.  The fact that this data has a row of 0s where frame 10
            #  has a row of 0s supports scaling  AND not-scaling gave very bad results-lots of splotches
            basevalues = ret9

        if status == 70: #change to 70 when not used
            #  Are these actually negative numbers?  Subtract 2^14 (16384) to find out
            # Perhaps offsets for the curve in "frame" 9?  Offsets for sensor reference??
            #  If so, do they need to be scaled by the factors of "Frame" 10?
            # Unscaled they run -692 to -858 (centers on -775, but most are -800+/-10), 
            # so I go for non-scaled.  BUT this "frame" also has that row of 0s
            negoffsets = ret9

        if status == 9:
            #  This appears to be the thermistor curve for the sensor, but there is a confusing 
            # discontinuity at pixel 14636 with a shallow curve after that
            # I am assuming that the curve ends at pixel 14635 & that it covers a range of 666 degrees F
            # with degrees on the pixel axis & "diffs" as the value of the "pixel"
            # The temperature in F above 40 below is the pixel number divided by 21.94
            # The value of the 2nd pixel (pixel 1?) in the image frames now defines the reference point on this curve
            # and by my calculations is a "diff" of 7679 at pixel 8716 (356 degrees F, or 180 degrees C)
            # an object's point on the curve is 7679-(image pixel 1)+(image-cal) & the temperature 
            # would be calculated by finding the corresponding pixel # in frame 9 & dviding by 21.94
            # then subtracting 40 to get temp relative to 0

            #calculate sensor reference point for this camera based on config file input
            #The sensor reference point identifies the ambient temperature as a function
            #of the value of pixel 1 in frameID3 & frameID1 and is used to calculate pixel 
            #temperatures in the pixelmath module

            ambientIndex = int(21.94 * (40 + ambientT)) #location of ambient temp on curve 9
            # The 291 number is the normalized "diff" value for the temperature difference between
            #the shutter and the temperature indicated by pixel 1--figured to be about 15 degrees F.
            #The actual number for that diff is 246, but I "fudged" it here in order to get 
            #closer temperature readings.  It might be more correct to fudge something else, though
            sensrref = 291 + pixel1atT + ((ret9[2*ambientIndex +1]<<8) + ret9[2*ambientIndex])

            curvebase = (ret9[2]+256*ret9[3])
            ix = 0
            index = 0
            while index < 11316:
              index  = (ret9[2*ix]+256*ret9[2*ix+1]) - curvebase
              if( (index > -1) & (index < 11317) ): 
                 diffcurve[index][0] = ix & 0xff
                 diffcurve[index][1] = ix >>8
              ix=ix+1

         #   fc = open("curve.txt", 'w')
         #   ix = 0
         #   while ix < index+1:
         #     s =  str(ix) +"\t"  +str( (diffcurve[ix][1]<<8) + diffcurve[ix][0]) +"\n"
         #     fc.write(s)
         #     ix=ix+1
         #  fc.close()


        if status == 10: #
            #  This is the pixel correction factors!  We can/[probably]should use this instead of ice cal
            #UNFORTUNATELY, for my camera, their correction factors have all 0 in the 28th line so I still need my file
            #for that line
            #*****ON 1-12-2016 I found that running the cal on a room temp. surface yields better 
            #results than using frame 10--at least near room temp., without applying offsets
            #to run that cal I set "diffshouldbe" to the ~median value of the diffs that came out
            #I verified that again in May 2016 when I got very good results using diffshouldbe of -400

            pixelmath.strip2col(ret9, frame10, basevalues)
            if(useframe10 >0): setframe10cal()

        if status == 1:
            if (useframe1 > 0): pixelmath.strip2col(ret9, calbfr, basevalues)
            if (useframe1 < 0): calbfr = refbfr
            if(firstcalframe ==0): firstcalframe = 1

#########
#Stuff to try to better track temperature changes in the device
            if( (thiscalframe < 1) & (nimage > 0 ) ):
                thiscalframe = nimage
                # Calculate the normalized value of the cal frame at the chosen pixel
                thiscalvalue = 100*( (ret9[2*calpixel+1]<<8) + ret9[2*calpixel])/badpxls[calpixel]

            if(thiscalframe > 0):
                priorcalframe = thiscalframe
                thiscalframe = nimage
                priorcalvalue = thiscalvalue
                thiscalvalue = 100*( (ret9[2*calpixel+1]<<8) + ret9[2*calpixel])/badpxls[calpixel]
#########
            nshutter = nshutter + 1


        if status == 3:
            pixelmath.strip2col(ret9, stripbfr, basevalues) #Remove the 2 garbage columns at right edge
            if(writetestfile >0): refbfr = ret9
            #Calculate sensor temperature from 2nd pixel value
            pixl1 = ((ret9[3]<<8) + ret9[2])

            #sensrref = 7679  #sensor temperature reference point on curve--Find ambient temp on curve 9,
                             #add that pixel's value to the value of pixel1 at that ambient temp.,
                             #then add 291 to get sensrref--the 291 is empirically determined & may be wrong
          #  if (useframe1 < 0): sensrref = 7279

            pxl40 = (ret9[2*40+1]<<8) + ret9[2*40]

#########
#Stuff to try to better track temperature changes in the device
            correction = 0
            if(priorcalframe > 0):
                framedelta = thiscalframe - priorcalframe
                pixeldelta = thiscalvalue - priorcalvalue

                if( (abs(pixeldelta) > 20) & (abs(pixeldelta) < 1000) ): # More than 2 degree F change between cal frames, but not the big jump
                    perframestep = pixeldelta/framedelta
                    correction = perframestep*(nimage - thiscalframe)
#########

   ##### Get an average of 10 frames worth of diffs for cal purposes, but only in ONE cal frame set
   ##### so as not to get different pixel bias values.
   ##### That is, try to get the first 10 frames after a cal frame.
   ##### Then create a set of pixel scaling factors from that (new idea 7-9-16)

            if( (avgcal <0) | ((avgcal >0) & (firstcalframe < 1)) ): firstimg = nimage
            if( (avgcal >0) & (firstcalframe > 0) ):
               #Do the addition in C because python takes too long on the Rpi
               pixelmath.addimages(stripbfr, calbfr, sumofimg, imgw, imgh, nimage, firstimg)

               if(nimage > (firstimg + 9) ):
                  avgcal = -1 
                  firstimg = 0
                  s = "calfile" + ".txt"
                  f2 = open(s, 'w')
                  ix = 0
                  while ix < imgw*imgh:
                    if(sumofimg[ix] > 0):sumofimg[ix] = 0 #Get rid of what will be negative numbers
                    s =  str( int(100*sumofimg[ix]/(diffshouldbe * 10) ) ) +"\n" #just write scaling factors
                    f2.write(s)
                    ix=ix+1
                  f2.close()
   #####

            nimage = nimage +1


            diffs = numpy.zeros((imgw*imgh), dtype=numpy.int16)

            if ( (freezeframe <0)  ): pixelmath.shuttercal(stripbfr, calbfr, tamfx22, rgbbfr, kclrs, badpxls, bwbfr, diffcurve, diffs, negoffsets, shutterbb, sensrref-correction, curvebase, bwcolor, pixelcorr, noraster, listfile, applyoffs, avg9, useshuttercal, ForC, mkr1tamf, tzoom, imgw, imgh)

            if( (listfile >0)  & (firstcalframe > 0) ): #Again, try to get the first frame after cal frame
               s = "pixellistScene" + str(nimage) + ".txt"
               f2 = open(s, 'w')
               s = "pxl#\tcal\timage\tdiff\tcorrdiff\tTAMF" + "\n"
               f2.write(s)
               ix = 0
               while ix < imgw*imgh:
                 s = str(ix) + "\t" + str( (calbfr[2*ix+1]<<8) + calbfr[2*ix]) +"\t"  +str( (ret9[2*ix+1]<<8) + ret9[2*ix]) + "\t" + str( ( (ret9[2*ix+1]<<8) + ret9[2*ix]) -( (calbfr[2*ix+1]<<8) + calbfr[2*ix]) ) + "\t" + str( diffs[ix] ) + "\t" + str(tamfx22[2*ix] + 256*tamfx22[2*ix +1]) +"\n"
                 f2.write(s)
                 ix=ix+1
               f2.close()
               firstcalframe = 0
               listfile = -1  #only write one file

            if( (firstcalframe > 0) & (avgcal <0) ): firstcalframe =0 #DON'T set this zero until cal average is done!

            #changed pixelmath on 10-27-15 to use rgbbfr for B&W also so eliminated all bwclr<>0 stuff
        #    pixelmath.scaleimg(rgbbfr, scalebfr, imgscale)
            clrimg = Image.fromstring("RGB", (imgw,imgh), rgbbfr)

       #     if(nimage ==0): disp_img.save("firstframe.png")
       #     if( (writetestfile < 1) & (nimage == 2) ):  disp_img.save("3rdframe.png")

            #  resize image for clarity --I tried doing this in the math module because the Rpi runs slow
            #  with 3x image, but it didn't help
            if(imgscale != 1): disp_img = clrimg.resize( (imgscale*imgw, imgscale*imgh)) 
            if(imgscale == 1): disp_img = clrimg 
            
            if (btndown > 0) | (btndown <0):  #originally had it so temp was only shown while button was down; now they stay until right click
               inc=0
               tscale = 21.94
               if(ForC < 0): tscale = 39.44

               while inc < Nmarkers:
                 mousepixel = (imgw*(ycoord[inc] /imgscale) + (xcoord[inc] /imgscale))
                 if(inc == 0): mkr1tamf = tamfx22[2*mousepixel] + 256*tamfx22[2*mousepixel +1]
                 pixeltemp = float(tamfx22[2*mousepixel] + 256*tamfx22[2*mousepixel +1])/tscale - 40
                 tempstr[inc] = chr(126)  + "%.1fF " %(pixeltemp)
                 if(ForC <0):tempstr[inc] = tempstr[inc] = chr(126)  + "%.1fC " %(pixeltemp)
                 draw = ImageDraw.Draw(disp_img)
                 draw.text((xcoord[inc]-2, ycoord[inc]-12), tempstr[inc], 0, font=font)
                 draw.text((xcoord[inc]+2, ycoord[inc]-12), tempstr[inc], 0, font=font )
                 draw.text((xcoord[inc], ycoord[inc]-14), tempstr[inc], 0, font=font)
                 draw.text((xcoord[inc], ycoord[inc]-10), tempstr[inc], 0, font=font )
                 draw.text((xcoord[inc], ycoord[inc]-12), tempstr[inc], 255, font=font)
                 inc = inc+1

   
            if ( (videorec > 0) & (freezeframe <0) ): #Don't record while capture is frozen
               pixelmath.swapBandR(rgbbfr)
               clrimg = Image.fromstring("RGB", (imgw,imgh), rgbbfr)
               if(imgscale != 1): clrimgB = clrimg.resize( (imgscale*imgw, imgscale*imgh))
               if(imgscale == 1): clrimgB = clrimg
               inc=0
               while inc < Nmarkers:
                 draw = ImageDraw.Draw(clrimgB)
                 draw.text((xcoord[inc]-3, ycoord[inc]-12), tempstr[inc],  font=font, fill=(255,255,255,0))
                 draw.text((xcoord[inc]+3, ycoord[inc]-12), tempstr[inc],  font=font, fill=(255,255,255,0))
                 draw.text((xcoord[inc], ycoord[inc]-15), tempstr[inc],  font=font, fill=(255,255,255,0))
                 draw.text((xcoord[inc], ycoord[inc]-9), tempstr[inc],  font=font, fill=(255,255,255,0))
                 draw.text((xcoord[inc], ycoord[inc]-12), tempstr[inc],  font=font, fill=(0,0,0,0))
                 inc = inc+1
               vidimg = numpy.asarray(clrimgB, dtype="uint8")
               out.write(vidimg) 

            if ( (saveit > 0)  ):
               now = datetime.datetime.now()
               strng = "frame" + str(now.year) + "-" + str(now.month) + "-" +  str(now.day) + "-" +  str(now.hour)  + str(now.minute) + str(now.second) + ".png"
               disp_img.save(strng)
               saveit = -1 #only write one file
               #also save full temperature (above -40) data as image--only for when I want histogram
            #   tafbimg = Image.fromstring("I", (imgw,imgh), tamfx22, "raw", "I;16")
            #   tafbimg.save('TAFB.png')
            
            return disp_img

def callback(event):    
        global saveit   
        saveit = saveit*-1   

def callbackb():    
        global saveit   
        saveit = saveit*-1   

def endpgm():    
        root.quit()  
        
root = Tkinter.Tk()
root.title('Thermal Image')
#root.geometry('+%d+%d' % (imgw,imgh))
if( (Rpiscreen == 1) & (imgscale == 3) ): root.overrideredirect(1) 
label_image = Tkinter.Label(root)
#label_image.pack()
label_image.place(x=0, y=0, width=imgscale*imgw, height=imgscale*imgh) #define h&w so it won't fill the main window & can bind mouse clicks to just the image


root.bind("<Escape>", lambda e: root.quit())
root.bind("<s>", callback)   
root.bind("<b>", callback2)   
root.bind("<p>", callback3)   
root.bind("<l>", callback4)   
root.bind("<z>", callback5)   
root.bind("<v>", callback6)   
root.bind("<c>", callback7)  #calibrate--make pixel correction factor file
label_image.bind("<Button-1>", mouseclick)  #capture mouse clicks ON the image "label" only
label_image.bind("<Button-3>", Rmouseclick)  #capture right mouse clicks
root.bind("<ButtonRelease-1>", mouseunclick)  #capture mouse un-clicks
#root.bind("<o>", offsetonoff)  #turn on/off applying diff curve offsets
#root.bind("<t>", shuttercalonoff)  #turn on/off applying shutter cal
#root.bind("<Return>", getcaltemp)   
root.bind("9", avg9pxl)
#root.bind("<a>", getframeavg)
root.bind("<k>", FahCent)
root.bind("<m>", zoomtemp)
root.bind("<i>", internalcal)


status = StringVar()
global lbl, b1, b2, b3, b4, b5, b6, b7
if(Rpiscreen <2):
  b1 = Button(root, text="Bw/Clr", command=callback2b)
  b1.place(x=imgscale*imgw, y=370, height=19, width=45)
  b2 = Button(root, text="S", command=callbackb)
  b2.place(x=imgscale*imgw+47, y=370, height=19, width=20)
  b3 = Button(root, text="V", command=callback6b)
  b3.place(x=imgscale*imgw+69, y=370, height=19, width=20)
  b4 = Button(root, text="Avg 9", command=avg9pxlb)
  b4.place(x=imgscale*imgw+91, y=370, height=19, width=47)
  b5 = Button(root, text="Freeze", command=freezeit)
  b5.place(x=imgscale*imgw, y=390, height=19, width=60)
  b6 = Button(root, text="Reset Markrs", command=clearmkrs)
  b6.place(x=imgscale*imgw+65, y=390, height=19, width=95)
  b7 = Button(root, text="Quit", command=endpgm)
  b7.place(x=imgscale*imgw+60, y=410, height=19, width=55)
  b8 = Button(root, text="F/C", command=FahCentb)
  b8.place(x=imgscale*imgw+138, y=370, height=19, width=40)
  b9 = Button(root, text="M1Z", command=zoomtempb)
  b9.place(x=imgscale*imgw+138, y=410, height=19, width=40)
  b10 = Button(root, text="Cal", command=calavg)
  b10.place(x=imgscale*imgw, y=410, height=19, width=40)
  lbl= Label(root, textvariable=status, fg='red', relief='raised').place(x=imgscale*imgw, y=430)

if(Rpiscreen == 2):
  b1 = Button(root, text="Bw/Clr", command=callback2b)
  b1.place(x=imgscale*imgw, y=111, height=19, width=45)
  b2 = Button(root, text="S", command=callbackb)
  b2.place(x=imgscale*imgw+47, y=111, height=19, width=20)
  b3 = Button(root, text="V", command=callback6b)
  b3.place(x=imgscale*imgw, y=131, height=19, width=20)
  b4 = Button(root, text="Avg 9", command=avg9pxlb)
  b4.place(x=imgscale*imgw+21, y=131, height=19, width=45)
  b5 = Button(root, text="Freeze", command=freezeit)
  b5.place(x=imgscale*imgw, y=151, height=19, width=60)
  b6 = Button(root, text="Rst Mkrs", command=clearmkrs)
  b6.place(x=imgscale*imgw, y=171, height=19, width=65)
  b7 = Button(root, text="Quit", command=endpgm)
  b7.place(x=imgscale*imgw, y=191, height=19, width=55)
  b8 = Button(root, text="F/C", command=FahCentb)
  b8.place(x=imgscale*imgw, y=211, height=19, width=30)
  b9 = Button(root, text="M1Z", command=zoomtempb)
  b9.place(x=imgscale*imgw+30, y=211, height=19, width=35)
  b10 = Button(root, text="Cal", command=calavg)
  b10.place(x=imgscale*imgw, y=231, height=19, width=40)
  lbl= Label(root, textvariable=status, fg='red', relief='raised').place(x=imgscale*imgw, y=251)

fps_t = 0
fps_f = 0




def show_frame(first=False):
    global fps_t, fps_f, pixl1, lbl, status, videorec, freezeframe, kclrs, pxl40, imgscale
  #  status.set("blank")
  #  lbl = Label()

    recdng = " "

    if( (videorec > 0) & (freezeframe < 0) & (Rpiscreen <2) ): recdng = "\n   **Recording**"
    if( (videorec > 0) & (freezeframe < 0) & (Rpiscreen ==2) ): recdng = "\n*Record*"

    disp_img = get_image()
    mainheight = 468
    if first: 
       if(disp_img.size[1] > mainheight): mainheight = disp_img.size[1]
       if(Rpiscreen <2): root.geometry('%dx%d' % (disp_img.size[0]+181, mainheight))
       if(Rpiscreen ==2): root.geometry('%dx%d' % (disp_img.size[0]+65, 313))

       #make a palette image for the main window
       tkpalette = Image.fromstring("RGB", (18, 37), kclrs) #666 colors is 18x37
       if(Rpiscreen <2): paletteb = tkpalette.resize( (180, 370))
       if(Rpiscreen == 2): paletteb = tkpalette.resize( (54, 111))
       tkpaletteb = ImageTk.PhotoImage(paletteb)
       pallbl = Label(root, image=tkpaletteb)
       pallbl.tkpaletteb = tkpaletteb
       if(Rpiscreen <2): pallbl.place(x=imgscale*imgw+1, y=0, width=180, height=370)
       if(Rpiscreen ==2): pallbl.place(x=imgscale*imgw+1, y=0, width=54, height=111)

    tkpi = ImageTk.PhotoImage(disp_img)
    label_image.imgtk = tkpi
    label_image.configure(image=tkpi)
    label_image.place(x=0, y=0, width=disp_img.size[0], height=disp_img.size[1])
    
    now = int(time.time())
    fps_f += 1
    if fps_t == 0:
        fps_t = now
    elif fps_t < now:
        if(Rpiscreen <2): status.set( " fps: " + str(1.0 * fps_f / (now-fps_t)) + "  pixel 1=" + str( pixl1) + recdng)
        if(Rpiscreen ==2): status.set( " fps: " + str(1.0 * fps_f / (now-fps_t)) + "\npx1=" + str( pixl1) + recdng)
        fps_t = now
        fps_f = 0

    label_image.after(1, show_frame)    # after 1ms, run show_frame again

#can get cursor position on screen (not the wiindow) by using print root.winfo_pointerxy()

show_frame(first=True)
root.mainloop() # UI has control until user presses <<Escape>>
cv2.destroyAllWindows()
if( (nimage < 12000) & (writetestfile > 0) ): ftest.close()